//+------------------------------------------------------------------+
//|                                                      CCI.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  MediumOrchid
#property indicator_width1  2

//
//
//
//
//

extern int    CCIPeriod          = 14;
extern int    CCIPrice           = PRICE_TYPICAL;
extern double levelOs            = -150;
extern double levelOb            = 150;
extern double UpperLevel         = -90;
extern double LowerLevel         = 90;

extern bool   alertsOn           = true;
extern bool   alertsOnLevelCross = true;
extern bool   alertsOnObOsCross  = true;
extern bool   alertsOnCurrent    = false;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsNotify       = false;
extern bool   alertsEmail        = false;

//
//
//
//
//

double cci[];
double prices[];
double trend1[];
double trend2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,cci);
      SetIndexBuffer(1,prices);
      SetIndexBuffer(2,trend1);
      SetIndexBuffer(3,trend2);
      SetLevelValue(0,levelOb);
      SetLevelValue(1,levelOs);
      SetLevelValue(2,UpperLevel);
      SetLevelValue(3,LowerLevel);
   IndicatorShortName("CCI ("+CCIPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,CCIPrice,i);
      double avg = 0; for(k=0; k<CCIPeriod; k++) avg +=         prices[i+k];      avg /= CCIPeriod;
      double dev = 0; for(k=0; k<CCIPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CCIPeriod;
         if (dev!=0)
               cci[i] = (prices[i]-avg)/(0.015*dev);
         else  cci[i] = 0;
         
         //
         //
         //
         //
         //
         
         trend1[i] = trend1[i+1];
         trend2[i] = 0;
         if (cci[i]<LowerLevel) trend1[i] =-1;
         if (cci[i]>UpperLevel) trend1[i] = 1;
         if (cci[i]>levelOb)    trend2[i] = 1;
         if (cci[i]<levelOs)    trend2[i] =-1;  
               
      }
manageAlerts();
return(0);
}      
   
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnLevelCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," crossing overbought up ");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," crossing oversold down ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnObOsCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar+1] == 1 && trend2[whichBar] != 1) doAlert(time2,mess2,whichBar," crossing overbought down  ");
            if (trend2[whichBar+1] ==-1 && trend2[whichBar] !=-1) doAlert(time2,mess2,whichBar," crossing oversold up ");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)," CCI ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," CCI "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}